"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Addon = void 0;
var _components = require("@storybook/components");
var _react = _interopRequireWildcard(require("react"));
var _Panel = require("./Panel");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const Addon = _ref => {
  let {
    active,
    browser,
    manager
  } = _ref;
  const [tests, setTests] = (0, _react.useState)([]);
  const [selectedTestId, setSelectedTestId] = (0, _react.useState)(manager.selectedTestId);
  (0, _react.useEffect)(() => {
    if (active) {
      manager.setActiveBrowser(browser);
      const browserTests = manager.getTestsByStoryIdAndBrowser(manager.activeBrowser);
      setTests(browserTests);
    }
  }, [active, browser, manager]);
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onChangeTest(testId => {
      setSelectedTestId(testId);
      const status = manager.getTestsByStoryIdAndBrowser(manager.activeBrowser);
      setTests(status);
    });
    return unsubscribe;
  }, [manager]);
  (0, _react.useEffect)(() => {
    const unsubscribe = manager.onUpdateStatus(() => {
      setTests(manager.getTestsByStoryIdAndBrowser(manager.activeBrowser));
    });
    return unsubscribe;
  }, [manager, browser]);
  return active ? tests.length ? /*#__PURE__*/_react.default.createElement(_Panel.Panel, {
    tests: tests,
    selectedTestId: selectedTestId,
    onChangeTest: manager.setSelectedTestId,
    onImageApprove: manager.onImageApprove
  }) : /*#__PURE__*/_react.default.createElement(_components.Placeholder, null, "No test results") : null;
};
exports.Addon = Addon;